package br.usp.ime.coed.DEFSupport;

import java.awt.geom.Point2D;
import java.util.List;
import java.util.ListIterator;

/**
 * Default implementation that searches over a specified List
 * in reverse sequencial way. This is because of the default
 * Z-order: top elements at last.
 * The first found element will be returned.
 */
public class DefaultDrawingElemenContainer
  implements DrawingElementContainer
//////////////////////////////////////////
{
  /**
   * The DrawingElements contained.
   */
  private List contents;

  /**
   * Initializes the contents to the specified Collection.
   * This can be an unmodifiable one.
   *
   * @param contents A List of DrawingElements.
   */
  public DefaultDrawingElemenContainer( List contents )
  /////////////////////////////////////////////////////
  {
    this.contents = contents;
  }

  /**
   * Indicates if there is or no a DrawingElement object at
   * the position especified. In the case of finding
   * more than one element, the one in the front will
   * be returned.
   * @param position the position to search at.
   * @return the <code>DrawingElement</code> object finded
   * (may be null if nothing is finded)
   */
  public DrawingElement searchElementAt( Point2D position )
  /////////////////////////////////////////////////////////
  {
    ListIterator it = contents.listIterator( contents.size() );
    DrawingElement ret = null; // default return value.
    while ( it.hasPrevious() && ret == null )
    {
      DrawingElement de = (DrawingElement)it.previous();
      if ( de.contains( position ) )
        ret = de;
    } // while

    return ret;
  }
}
