package br.usp.ime.coed.DEFSupport;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.geom.Rectangle2D;

import javax.swing.JComponent;

/**
 * Visual feedback of the dragging process.
 */
public class DragProcessDisplayer
/////////////////////////////////
{
  private JComponent clientComponent;
  private Rectangle2D lastBoundsDisplayed; // may be null.
  private static final Stroke DRAG_STROKE =
    new BasicStroke ( 3.0F, BasicStroke.CAP_ROUND, BasicStroke.JOIN_BEVEL );
  private static final Color DRAG_COLOR = Color.gray.brighter();//new Color(104, 158, 250); //Color.blue.darker();

  public DragProcessDisplayer( JComponent clientComponent )
  /////////////////////////////////////////////////////////
  {
    this.clientComponent      = clientComponent;
    this.lastBoundsDisplayed  = null;
  }


  public void drawingElementDragged( DrawingElement de )
  //////////////////////////////////////////////////////
  {
    Rectangle2D bounds = null;
    if ( de != null )
    {
      bounds = de.getBounds();

      // -- Prepare painting mode.
      Graphics2D g2 = (Graphics2D)clientComponent.getGraphics();
      g2.setXORMode( clientComponent.getBackground() );
      g2.setColor( DRAG_COLOR );
   //   Stroke oldStroke = g2.getStroke();
    //  g2.setStroke( DRAG_STROKE );

      // -- Delete old bound and draw new one.
  /*    if ( lastBoundsDisplayed != null )
        g2.draw( lastBoundsDisplayed );
      g2.draw( bounds );*/

     if(lastBoundsDisplayed != null)
        g2.fill3DRect((int)lastBoundsDisplayed.getX(), (int)lastBoundsDisplayed.getY(),
                      (int)lastBoundsDisplayed.getWidth(), (int)lastBoundsDisplayed.getHeight(), true);

      g2.fill3DRect((int)bounds.getX(), (int)bounds.getY(),
                    (int)bounds.getWidth(), (int)bounds.getHeight(), true);
      // -- Restore painting mode.
      g2.setPaintMode();
    //  g2.setStroke( oldStroke );
    }

    // -- Remember last one. Should be cloned because otherwise it will be
    //    the same as bounds.
    lastBoundsDisplayed = (bounds == null) ? null : (Rectangle2D)bounds.clone() ;
  }


  public void drawingElementEndDrag()
  ///////////////////////////////////
  {
    // -- When dropped, can repaint all.
    clientComponent.repaint();
    lastBoundsDisplayed = null;
  }
} // class DragProcessDisplayer
