package br.usp.ime.coed.DEFSupport;

import java.awt.geom.Point2D;

/**
 * Container of DrawingElements.
 * Should know to return one of its contained elements (de) that
 * verifies <TT> de.contains( somePosition ) </TT>
 *
 * Should be nested class of DrawingElementFinder, but I don't
 * know how to show relationships while using TogetherJ .
 */
public interface DrawingElementContainer
////////////////////////////////////////
{
  /**
   * Return one of its contained elements (de) that verifies
   *  <TT> de.contains( position )</TT>
   * If more than one object verifies that condition, is responsability
   * of the concrete class to decide the strategy.
   *
   * If no object verifies, returns null.
   *
   * @param positon
   * @return
   */
  DrawingElement searchElementAt( Point2D positon );
  //////////////////////////////////////////////////

} // interface DrawingElementContainer
