package br.usp.ime.coed.DEFSupport;

import java.awt.geom.Point2D;
import java.util.List;

/**
 * Idem DefaultDrawingContainer, but also process a DrawingElementSelection,
 * which has more priority.
 * Useful for dragging selections.
 */
public class SelectionAwareDrawingElemenContainer extends DefaultDrawingElemenContainer
///////////////////////////////////////////////////////////////////////////////////////
{
  /**
   * @supplierRole selection
   * @supplierCardinality 1
   */
  private DrawingElementSelection selection;

  public SelectionAwareDrawingElemenContainer( List contents,
                                               DrawingElementSelection selection )
  ////////////////////////////////////////////////////////////////////////////////
  {
    super( contents );
    this.selection = selection;
  }

  public DrawingElement searchElementAt( Point2D position )
  /////////////////////////////////////////////////////////
  {
    if ( selection.contains( position ) )
      return selection;
    else
      return super.searchElementAt( position );
  }
}