/* Generated by Together */

package br.usp.ime.coed.DEFSupport;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;

/**
 * Displays a selection.
 */
public class SelectionDisplayer
///////////////////////////////
{
  /**
   * @supplierRole selector
   * @supplierCardinality 1
   */
  private DrawingElementSelection selector;
  public static final Color SELECTION_COLOR = Color.blue.darker().darker();
  public static final Stroke SELECTION_STROKE =
    new BasicStroke ( 2.0F, BasicStroke.CAP_ROUND, BasicStroke.JOIN_BEVEL, 10.0F,
                      new float[]{ 25, 4 , 8 , 4 }, 0 );
  private static final Stroke FILLED_SELECTION_STROKE =
    new BasicStroke (4.0F, BasicStroke.CAP_ROUND, BasicStroke.JOIN_BEVEL);
  private Color filledSelectionColor;
  private static final int SELECTOR_POINT_SIZE = 4;
  private static Rectangle2D.Double selectorPoint =
    new Rectangle2D.Double( 0, 0, SELECTOR_POINT_SIZE * 2, SELECTOR_POINT_SIZE * 2 );

private boolean fillLine;


  public SelectionDisplayer( DrawingElementSelection selector )
  ////////////////////////////////////////////////////////////
  {
    this.selector = selector;
    fillLine = false;
  }


  /**
   * Draws the selection on the element de.
   * de must be not null.
   */
  public void drawSelectionOn( Graphics2D g2, DrawingElement de  )
  ///////////////////////////////////////////////////////////////
  {
    Rectangle2D bounds = de.getBounds();

    if(fillLine)
      drawOutline(g2, bounds, FILLED_SELECTION_STROKE, filledSelectionColor);
     else{

      drawOutline(g2, bounds, SELECTION_STROKE, SELECTION_COLOR);
    // -- Draw bounding box.
    /*Rectangle2D bounds = de.getBounds();
    g2.setColor( SELECTION_COLOR );
    Stroke oldStroke = g2.getStroke();
    g2.setStroke( SELECTION_STROKE );
    g2.draw( bounds );
    g2.setStroke( oldStroke );*/

    // -- Draw selector points.
    double leftX    = bounds.getMinX() - SELECTOR_POINT_SIZE;
    double rightX   = bounds.getMaxX() - SELECTOR_POINT_SIZE;
    double upperY   = bounds.getMinY() - SELECTOR_POINT_SIZE;
    double bottomY  = bounds.getMaxY() - SELECTOR_POINT_SIZE;

    selectorPoint.x = leftX;
    selectorPoint.y = upperY;
    g2.fill( selectorPoint );

    selectorPoint.x = leftX;
    selectorPoint.y = bottomY ;
    g2.fill( selectorPoint );

    selectorPoint.x = rightX;
    selectorPoint.y = bottomY;
    g2.fill( selectorPoint );

    selectorPoint.x = rightX;
    selectorPoint.y = upperY;
    g2.fill( selectorPoint );
    }


  }

  public void drawOutline (Graphics2D g, Rectangle2D bounds, Stroke stroke, Color color){

      g.setColor( color  );
      Stroke oldStroke = g.getStroke();
      g.setStroke( stroke );
      g.draw( new Rectangle2D.Double( bounds.getX() - 2, bounds.getY() - 2,
                                      bounds.getWidth() + 3 + 1, bounds.getHeight() + 3 + 1) );
      g.setStroke( oldStroke );
  }

  public void drawSelectionOn( Graphics2D g2 )
  ////////////////////////////////////////////
  {
    Iterator it = selector.getSelectedElements().iterator();
    while ( it.hasNext() )
    {
      this.drawSelectionOn( g2, (DrawingElement)it.next() );
    } // while
  }

  public void filledSelection(Color color){
    fillLine = true;
    filledSelectionColor = color;
  }

  public void dashedSelection(){
    fillLine = false;
  }

}
