package br.usp.ime.coed;

import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.view.ApplicationView;

/**
 * Main class.
 */
public class Main {

    private String egeneDir;

    private String configurationFile;

    private static Main runner;

    private Main() {
        egeneDir = ".";
        configurationFile = "./conf/egene.cnf";
    }

    /**
     * Singleton, only one instance of this class can exists.
     * 
     * @return
     */
    public static Main getInstance() {
        if (runner == null) {
            runner = new Main();
        }
        return runner;
    }

    /**
     * Run the coed
     */
    public void run() {
        ApplicationView view = new ApplicationView(new ApplicationModel());
        view.setVisible(true);
    }

    /**
     * Main method.
     * 
     * @param args
     *            the execution args
     */
    public static void main(String[] args) {
        Main r = Main.getInstance();
        if (args.length < 1) {
            System.err.println("Missing egene directory dir");
        } else {
            r.setEgeneDir(args[0]);
        }
        if (args.length == 2) {
            r.setConfigurationFile(args[1]);
        }
        r.run();
    }

    /**
     * @return returns the egene directory path
     */
    public String getEgeneDir() {
        return egeneDir;
    }

    /**
     * .
     */
    public void setEgeneDir(String egeneDir) {
        this.egeneDir = egeneDir;
        if(egeneDir.equals("")){
            this.egeneDir = ".";
        }
    }

    /**
     * @return Returns the configuration file.
     */
    public String getConfigurationFile() {
        return  configurationFile;
    }

    /**
     * @param configurationFile
     *            is the configuration file
     */
    public void setConfigurationFile(String configurationFile) {
        this.configurationFile = configurationFile;
    }
}