package br.usp.ime.coed;

import java.awt.Color;

/**
 * Contains the colors used in the program.
 */

public class ProgramColors {

  /**
   * The animation color.
   */
  private static final Color ANIMATION_COLOR = new Color(104, 158, 250);
  /**
   * The default color.
   */
  private static final Color DEFAULT_COLOR = (new Color(20, 100, 255)).darker();

  /**
   * Returns the animation color.
   * @return a <code>Color</code>
   */
  public static Color getAnimationColor(){
    return ANIMATION_COLOR;
  }

  /**
   * Returns the selection color.
   * @return a <code>Color</code>
   */
  public static Color getSelectionColor(){
    return DEFAULT_COLOR;
  }

  /**
   * Returns the pipe color.
   * @return a <code>Color</code>
   */
  public static Color getPipeColor(){
    return DEFAULT_COLOR;
  }
}