/*
 * Criado em 02/11/2004
 */
package br.usp.ime.coed.action;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.utils.RunPipeline;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.RunPipelineForm;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class RunPipelineAction extends FormattedAction {

    ApplicationView view;

    public RunPipelineAction(ApplicationView view) {
        super("run pipeline", Main.getInstance().getEgeneDir()
                + "/images/run_button.gif");
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        CoedDocument document = view.getApplicationModel().getDocManager()
                .getCurrentDocument();
        RunPipeline pipe = new RunPipeline();
        pipe.setCoedDocument(document);
        
        if(!(document.getAllComponents().size() > 0 && document.getFirstComponent() != null)){
			JOptionPane.showMessageDialog(view,
					"Your pipeline is not complete.\n"
							+ "Please, choose a component as the first "
							+ "process and try again.");
			view.setStatus("Action canceled.");
            return; 
        }
        
        RunPipelineForm form = new RunPipelineForm(pipe, view);
        form.show();
     
    }

}