/*
 * Criado em 24/10/2004
 */
package br.usp.ime.coed.action.edit;

import javax.swing.JMenu;
import javax.swing.JToolBar;

import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class EditMenuActions {

    private UndoAction undo;
    private RedoAction redo;
    private CopyAction copy;
    private CutAction cut;
    private PasteAction paste;
    private ClearSelectionAction clear;
    private SelectAllAction selectAll;
 
    public EditMenuActions(ApplicationView view) {
        undo = new UndoAction(view);
        redo = new RedoAction(view);
        copy = new CopyAction(view);
        cut = new CutAction(view);
        paste = new PasteAction(view);
        clear = new ClearSelectionAction(view);
        selectAll = new SelectAllAction(view);
    }
    
    public void addTo(JToolBar tool){
        tool.addSeparator();
        copy.addTo(tool);
        cut.addTo(tool);
        paste.addTo(tool);
        tool.addSeparator();
        undo.addTo(tool);
        redo.addTo(tool);
    }

    /**
     * @param editMenu
     */
    public void addTo(JMenu editMenu) {
        copy.addTo(editMenu);
        cut.addTo(editMenu);
        paste.addTo(editMenu);
        undo.addTo(editMenu);
        redo.addTo(editMenu);
        editMenu.addSeparator();
        clear.addTo(editMenu);
        selectAll.addTo(editMenu);
    }

    public ClearSelectionAction getClear() {
        return clear;
    }
    public CopyAction getCopy() {
        return copy;
    }
    public CutAction getCut() {
        return cut;
    }
    public PasteAction getPaste() {
        return paste;
    }
    public RedoAction getRedo() {
        return redo;
    }
    public SelectAllAction getSelectAll() {
        return selectAll;
    }
    public UndoAction getUndo() {
        return undo;
    }
    /**
     * @param b
     */
    public void setAllEnable(boolean b) {
        copy.setEnabled(b);
        cut.setEnabled(b);
        paste.setEnabled(b);
        undo.setEnabled(b);
        redo.setEnabled(b);
        clear.setEnabled(b);
        selectAll.setEnabled(b);
    }
}