/*
 * Criado em 24/10/2004
 */
package br.usp.ime.coed.action.edit;

import java.awt.event.ActionEvent;
import java.util.Observable;
import java.util.Observer;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.model.CoedDocumentCareTaker;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class RedoAction extends FormattedAction implements Observer {
    private ApplicationView view;

    private ApplicationModel model;

    public RedoAction(ApplicationView view) {
        super("Redo", 'r', Main.getInstance().getEgeneDir()
                + "/images/edit/redo.gif");

        this.view = view;
        this.model = view.getApplicationModel();
        setEnabled(false);

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        try {
            CoedDocument doc = view.getTabPane().getSelectedDocument();
            CoedDocumentCareTaker careTaker = model.getDocManager()
                    .getDocumentCareTaker(doc);
            doc.setMemento(careTaker.redo(doc));
        } catch (IllegalAccessError error) {
            view.setStatus(error.getMessage());
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
     */
    public void update(Observable o, Object arg) {
        String action = (String) arg;
        setEnabled(false);
        try {
            if (action.equals(CoedDocumentCareTaker.CHANGED)) {
                CoedDocumentCareTaker careTaker = (CoedDocumentCareTaker) o;
                if (careTaker.redoSize() <= 0) {
                    setEnabled(false);
                } else {
                    setEnabled(true);
                }
            }
        } catch (Exception e) {
            setEnabled(false);
        }

    }

}