/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.fileMenu;

import java.awt.event.ActionEvent;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

import javax.swing.JOptionPane;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class ExitAction extends FormattedAction {
    ApplicationView view;

    public ExitAction(ApplicationView view) {
        super("Exit", 'x');
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        CoedDocumentManager manager = view.getApplicationModel()
                .getDocManager();
        HashMap documents = manager.getDocuments();
        HashSet toClose = new HashSet();
        Iterator it = documents.keySet().iterator();
        while (it.hasNext()) {
            String name = (String) it.next();
            toClose.add(name);
        }
        it = toClose.iterator();
        while (it.hasNext()) {
            String name = (String) it.next();
            manager.setCurrentDocument((CoedDocument) documents.get(name));
            manager.notifyObservers(CoedDocumentManager.CURRENT_CHANGED);
            CoedDocument selected = manager.getCurrentDocument();
            int result = JOptionPane.NO_OPTION;
            if (selected.modified()) {
                result = JOptionPane.showConfirmDialog(view, "The file "
                        + selected.getName()
                        + " was modified. \nDo you want to save alterations ?",
                        "SAVE " + selected.getName() + "?",
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE);
            }
            if (result == JOptionPane.YES_OPTION) {
                try {
                    view.getApplicationModel().getDocManager().saveDocument();
                } catch (Exception e1) {
                    view.setStatus(e1.getMessage());
                }
            } else if (result == JOptionPane.CANCEL_OPTION) {
                return;
            }
        }
        view.setVisible(false);
        System.exit(0);
    }

}