/*
 * Created on 22/10/2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package br.usp.ime.coed.action.fileMenu;

import javax.swing.JMenu;
import javax.swing.JToolBar;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author yoshiaki Contains all file actions
 */
public class FileMenuActions {
    // Create the actions
    private FormattedAction newAction;

    private FormattedAction openAction;

    private FormattedAction saveAction;

    private FormattedAction saveAllAction;

    private FormattedAction saveAsAction;

    private FormattedAction closeAction;

    private FormattedAction closeAllAction;

    private FormattedAction exitAction;

    private FormattedAction importEGeneAction;

    private FormattedAction exportEGeneAction;

    public FileMenuActions(ApplicationModel model, ApplicationView view) {
        importEGeneAction = new ImportEGeneConfigurationAction(view);
        exportEGeneAction = new ExportEGeneConfigurationAction(view);
        newAction = new NewFileAction(view);
        openAction = new OpenFileAction(view);
        saveAction = new SaveFileAction(view);
        saveAsAction = new SaveAsFileAction(view);
        closeAction = new CloseFileAction(view);
        exitAction = new ExitAction(view);
        saveAction.setEnabled(false);
        saveAsAction.setEnabled(false);
    }


    /**
     * Add the actions into menu
     * 
     * @param menu
     */
    public void addTo(JMenu menu) {
        newAction.addTo(menu);
        menu.addSeparator();
        openAction.addTo(menu);
        menu.addSeparator();
        saveAction.addTo(menu);
        saveAsAction.addTo(menu);
        menu.addSeparator();
        importEGeneAction.addTo(menu);
        exportEGeneAction.addTo(menu);
        menu.addSeparator();
        closeAction.addTo(menu);
        menu.addSeparator();
        exitAction.addTo(menu);
    }

    /**
     * Add the actions into tool bar
     * 
     * @param toolBar
     */
    public void addTo(JToolBar bar) {
        newAction.addTo(bar);
        openAction.addTo(bar);
        saveAction.addTo(bar);
        closeAction.addTo(bar);
    }

    public void setDepedentEnable(boolean val) {
        saveAction.setEnabled(val);
        saveAsAction.setEnabled(val);
        closeAction.setEnabled(val);
    }

    public void setInitialActionEnable(boolean val) {
        newAction.setEnabled(val);
        importEGeneAction.setEnabled(val);
        exitAction.setEnabled(val);
        openAction.setEnabled(val);
    }

    
    /**
     * Enbble actions
     */
    public void setAllEnable(boolean val) {
        newAction.setEnabled(val);
        openAction.setEnabled(val);
        exportEGeneAction.setEnabled(val);
        saveAction.setEnabled(val);
        saveAsAction.setEnabled(val);
        closeAction.setEnabled(val);
        exitAction.setEnabled(val);
    }



    public FormattedAction getCloseAction() {
        return closeAction;
    }
    public FormattedAction getCloseAllAction() {
        return closeAllAction;
    }
    public FormattedAction getExitAction() {
        return exitAction;
    }
    public FormattedAction getNewAction() {
        return newAction;
    }
    public FormattedAction getOpenAction() {
        return openAction;
    }
    public FormattedAction getSaveAction() {
        return saveAction;
    }
    public FormattedAction getSaveAllAction() {
        return saveAllAction;
    }
    public FormattedAction getSaveAsAction() {
        return saveAsAction;
    }
    public FormattedAction getExportEGeneAction() {
        return exportEGeneAction;
    }
}