/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;

import br.usp.ime.coed.ReadEgeneConfiguration;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;
import br.usp.ime.coed.view.IconValuesForm;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class ChangeValuesAction extends FormattedAction {

    GraphicalIconElement icon;

    ApplicationView view;

    public ChangeValuesAction(ApplicationView view) {
        super("Change values", "c");
        this.view = view;
    }

    /*
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        if (icon.getComponent().getType() == ReadEgeneConfiguration
                .getInstance().getNullType()) {
            JOptionPane.showMessageDialog(view,"Invalid component type, delete it and put a valid one.");
            view.setStatus("Action canceled. " + "Invalid component type, delete it and put a valid one.");
            return;
        }
  
        new IconValuesForm(icon, view);
    }

    /**
     * @param icon
     *            The icon to set.
     */
    public void setIcon(GraphicalIconElement icon) {
        this.icon = icon;
    }
}