/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;
import java.util.Iterator;

import br.usp.ime.coed.DEFSupport.DrawingElement;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class DeleteDrawingIconElementAction extends FormattedAction {

	DrawingElement icon;

	ApplicationView view;

	public DeleteDrawingIconElementAction(ApplicationView view) {
		super("Delete icon", "d");
		this.view = view;
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		view.getApplicationModel().getDocManager().saveCurrentDocumentState();
		if (icon instanceof GraphicalIconElement ) {
		    view.getApplicationModel().getDocManager().getCurrentDocument().removeComponent(((GraphicalIconElement)icon).getComponent());
		}else{
		    Iterator it = view.getTabPane().getSelectedGraphicPane().getSelection().getSelectedElements().iterator();
	        while(it.hasNext()){
	            GraphicalIconElement element = (GraphicalIconElement) it.next();
	            element.getComponent().isSelected(false);
			    view.getApplicationModel().getDocManager().getCurrentDocument().removeComponent(element.getComponent());
	        }
		}
	}

	/**
	 * @param icon The icon to set.
	 */
	public void setIcon(DrawingElement icon) {
		this.icon = icon;
	}
}