/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class DeleteIncomingPipesAction extends FormattedAction {

	GraphicalIconElement icon;

	ApplicationView view;

	public DeleteIncomingPipesAction(ApplicationView view) {
		super("Delete  incoming pipes", "i");
		this.view = view;
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		view.getApplicationModel().getDocManager().saveCurrentDocumentState();
		CoedDocument document = view.getApplicationModel().getDocManager().getCurrentDocument();
		document.removeIncomePipe(icon.getComponent());
	}

	/**
	 * @param icon The icon to set.
	 */
	public void setIcon(GraphicalIconElement icon) {
		this.icon = icon;
	}
}