/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.Component;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class SetPositionAction extends FormattedAction {

	GraphicalIconElement icon;

	ApplicationView view;

	public SetPositionAction(ApplicationView view) {
		super("Set position", "p");
		this.view = view;
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		
		Component c = icon.getComponent();

		Box boxX = Box.createHorizontalBox(), boxY = Box.createHorizontalBox();
		boxX.add(new JLabel("x: "));
		JTextField xField = new JTextField();
		boxX.add(xField);
		xField.setText("" + c.getX());
		boxY.add(new JLabel("y: "));
		JTextField yField = new JTextField();
		boxY.add(yField);
		yField.setText("" + c.getY());
		Box positionBox = Box.createVerticalBox();
		positionBox.add(boxX);
		positionBox.add(boxY);

		int result = JOptionPane.showOptionDialog(view, positionBox,
				"Set position", JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.PLAIN_MESSAGE, null, null, null);

		if (result == JOptionPane.CANCEL_OPTION)
			return;
		try {
			view.getApplicationModel().getDocManager().saveCurrentDocumentState();
			c.setPosition(Double.parseDouble(xField.getText()), Double
					.parseDouble(yField.getText()));
		} catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(view, "Value not recognized.\n"
					+ "You should digit a number in the x and y fields.",
					"ERROR", JOptionPane.ERROR_MESSAGE);
			return;
		}
	}

	/**
	 * @param icon The icon to set.
	 */
	public void setIcon(GraphicalIconElement icon) {
		this.icon = icon;
	}
}