/*
 * Criado em 24/10/2004
 */
package br.usp.ime.coed.behaviour;

import java.awt.event.MouseEvent;

import br.usp.ime.coed.DEFSupport.DefaultDEFBehaviour;
import br.usp.ime.coed.DEFSupport.DrawingElement;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.model.CoedDocumentCareTaker;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class CoedDefaultBehaviour extends DefaultDEFBehaviour {
    ApplicationView view;

    /**
     * @param client
     */
    public CoedDefaultBehaviour(ApplicationView view) {
        super(view.getTabPane().getSelectedGraphicPane());
        this.view = view;
    }
    /* (non-Javadoc)
     * @see br.usp.ime.coed.DEFSupport.DefaultDEFBehaviour#mouseClicked(java.awt.event.MouseEvent)
     */
    public void mouseClicked(MouseEvent e) {
        super.mouseClicked(e);
        view.setStatus(" ");
    
    }
    /*
     * (non-Javadoc)
     * 
     * @see br.usp.ime.coed.DEFSupport.DefaultDEFBehaviour#mousePressed(java.awt.event.MouseEvent)
     */
    public void mousePressed(MouseEvent e) {
        DrawingElement pointedElement = null;
        GraphicPane pane = view.getTabPane().getSelectedGraphicPane();
        try {
            pointedElement = pane.getContainer().searchElementAt(e.getPoint());
        } catch (ClassCastException cce) {
        } catch (NullPointerException npe) {
        }
        if (pointedElement != null) {
            CoedDocument doc = view.getTabPane().getSelectedDocument();
            CoedDocumentCareTaker careTaker = view.getApplicationModel()
                    .getDocManager().getDocumentCareTaker(doc);
            careTaker.addMemento(doc.createMemento());
            doc.setNotSaved(true);
        }
        super.mousePressed(e);
    }

}