/*
 * Criado em 26/10/2004
 */
package br.usp.ime.coed.model;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class TransferAreaManager {
    /**
     * The transfer area memory
     */
    private CoedDocument document;

    public TransferAreaManager() {
        document = new CoedDocument();
    }

    /**
     * Copy selected components
     */
    public void copy(Set selectedComponents) {
        document.getAllComponents().clear();
        document.getFirstComponents().clear();
        Iterator it = selectedComponents.iterator();
        HashMap origToNew = new HashMap();
        // Add selected components
        while (it.hasNext()) {
            Component origC = (Component) it.next();
            Component c = new Component(origC.getType());
            c.setPhase(new String(origC.getPhase()));
            c.setX(origC.getX());
            c.setY(origC.getY());
            document.addComponent(c);
            origToNew.put(origC, c);
            HashMap mandatory = (HashMap) origC.getMandatoryValues();
            HashMap newM = new HashMap();
            Iterator it3 = mandatory.keySet().iterator();
            while (it3.hasNext()) {
                String key = (String) it3.next();
                newM.put(key, mandatory.get(key));
            }
            HashMap optional = (HashMap) origC.getOptionalValues();
            HashMap newOp = new HashMap();
            it3 = optional.keySet().iterator();
            while (it3.hasNext()) {
                String key = (String) it3.next();
                newOp.put(key, optional.get(key));
            }
            c.setMandatoryValues(newM);
            c.setOptionalValues(newOp);
        }
        // Add all pipes
        it = origToNew.keySet().iterator();
        while (it.hasNext()) {
            Component origC = (Component) it.next();
            Iterator it2 = origC.getNextComponents().iterator();
            while (it2.hasNext()) {
                document.addPipe((Component) origToNew.get(origC),
                        (Component) origToNew.get(it2.next()));

            }
        }
    }

    /**
     * paste copied components
     */
    public void paste(CoedDocument doc) {
        Iterator it = doc.getAllComponents().iterator();
        while (it.hasNext()) {
            Component c = (Component) it.next();
            c.isSelected(false);
        }
        it = document.getAllComponents().iterator();
        HashMap origToNew = new HashMap();
        // Add selected components
        while (it.hasNext()) {
            Component origC = (Component) it.next();
            Component c = new Component(origC.getType());
            c.setPhase(new String(origC.getPhase()));
            origC.setX(origC.getX() + 5.0);
            origC.setY(origC.getY() + 5.0);
            c.setX(origC.getX());
            c.setY(origC.getY());
            doc.addComponent(c);
            c.isSelected(true);
            origToNew.put(origC, c);
            HashMap mandatory = (HashMap) origC.getMandatoryValues();
            HashMap newM = new HashMap();
            Iterator it3 = mandatory.keySet().iterator();
            while (it3.hasNext()) {
                String key = (String) it3.next();
                newM.put(key, mandatory.get(key));
            }
            HashMap optional = (HashMap) origC.getOptionalValues();
            HashMap newOp = new HashMap();
            it3 = optional.keySet().iterator();
            while (it3.hasNext()) {
                String key = (String) it3.next();
                newOp.put(key, optional.get(key));
            }
            c.setMandatoryValues(newM);
            c.setOptionalValues(newOp);
        }
        // Add all pipes
        it = origToNew.keySet().iterator();
        while (it.hasNext()) {
            Component origC = (Component) it.next();
            Iterator it2 = origC.getNextComponents().iterator();
            while (it2.hasNext()) {
                doc.addPipe((Component) origToNew.get(origC),
                        (Component) origToNew.get(it2.next()));
 
            }
        }

    }

    /**
     * cut selected components
     */
    public void cut(Set selectedComponents, CoedDocument document) {
        copy(selectedComponents);
        Iterator it = selectedComponents.iterator();
        while (it.hasNext()) {
            Component c = (Component) it.next();
            c.isSelected(false);
            document.removeComponent(c);
        }
    }
}