/*
 * Criado em 28/10/2004
 */
package br.usp.ime.coed.test;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.ImageIcon;

import junit.framework.TestCase;
import br.usp.ime.coed.Main;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.model.ComponentType;
import br.usp.ime.coed.model.TransferAreaManager;

/**
 * The application mode test case
 * 
 * @see br.usp.ime.coed.model.ApplicationModel
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class ApplicationModelTest extends TestCase {

    private ApplicationModel model;

    /*
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        Main r = Main.getInstance();
        r.setConfigurationFile("test/test.cnf");
        model = new ApplicationModel();
    }

    public void testGetIcon() {
        assertNotNull(model.getIcon());
    }

    public void testSetIcon() {
        ImageIcon icon = new ImageIcon();
        model.setIcon(icon);
        assertEquals(icon, model.getIcon());
    }

    public void testGetName() {
        assertEquals(model.getName(), "EGene configuration editor");
    }

    public void testSetName() {
        model.setName("BLAH");
        assertEquals(model.getName(), "BLAH");
    }

    public void testGetComponentTypeList() {
        assertTrue(model.getComponentsType().size() == 2);
        Iterator it = model.getComponentsType().iterator();
        while (it.hasNext()) {
            ComponentType type = (ComponentType) it.next();
            String name = type.getName();
            assertTrue(name.equals("teste1") || name.equals("teste2"));
        }
    }

    public void testSetComponentTypeList() {
        List newList = new ArrayList();
        List old = model.getComponentsType();
        model.setComponentsType(newList);
        assertTrue(model.getComponentsType() == newList);
        model.setComponentsType(old);
        assertTrue(model.getComponentsType() == old);
    }
    
    public void testGetDocManager(){
       assertTrue( model.getDocManager() != null);
    }
    
    public void testSetDocManager(){
        CoedDocumentManager manager = model.getDocManager();
        model.setDocManager(null);
        assertNull(model.getDocManager());
        model.setDocManager(manager);
        assertNotNull(model.getDocManager());
    }

    public void testGetTransferArea(){
       assertNotNull(model.getTransferAreaManager());
    }

    public void testSetTransferArea(){
        TransferAreaManager manager = model.getTransferAreaManager();
        model.setTransferAreaManager(null);
        assertNull(model.getTransferAreaManager());
        model.setTransferAreaManager(manager);
        assertNotNull(model.getTransferAreaManager());
    }
} 