/*
 * Criado em 18/11/2004
 */
package br.usp.ime.coed.view;

import javax.swing.JCheckBox;
import javax.swing.JPopupMenu;

import br.usp.ime.coed.DEFSupport.DrawingElement;
import br.usp.ime.coed.DEFSupport.DrawingElementSelection;
import br.usp.ime.coed.action.iconElement.DeleteDrawingIconElementAction;
import br.usp.ime.coed.action.iconElement.DeletePipelinesAction;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class DrawingElementSelectionMenu extends JPopupMenu {

	private ApplicationView view;

	private DrawingElementSelection element;

	private DeleteDrawingIconElementAction deleteIconAction;

	private DeletePipelinesAction deletePipelinesAction;

	private JCheckBox showPipelineName;
	
	private static DrawingElementSelectionMenu instance = null;

	public static DrawingElementSelectionMenu getInstance(ApplicationView view,
			DrawingElement de) {
		if (instance == null)
			instance = new DrawingElementSelectionMenu(view);
		instance.setDrawingElement(de);
		return instance;

	}

	public void setDrawingElement(DrawingElement de) {
		this.element = (DrawingElementSelection)de;
		deletePipelinesAction.setIcon(element);
		deleteIconAction.setIcon(element);
	}

    public DrawingElementSelectionMenu(ApplicationView view) {
		super();
		this.view = view;
		createMenuItens();
	}

	private void createMenuItens() {
	    deletePipelinesAction = new DeletePipelinesAction(view);
	    deleteIconAction = new DeleteDrawingIconElementAction(view);
		deleteIconAction.addTo(this);
		deletePipelinesAction.addTo(this);
	}

	public void setAllActionsEnable(boolean b) {
	    deletePipelinesAction.setEnabled(b);
	    deleteIconAction.setEnabled(b);
	}
}
